> For the complete documentation index, see [llms.txt](https://docs.tonic.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tonic.ai/app/api/quick-start-guide/tonic-api-generator-assignment/generator-api-reference/generator-api-ref-array-regex-mask.md).

# Array Regex Mask (ArrayRegexMaskGenerator)

The [Array Regex Mask](/app/generation/generators/generator-reference/array-regex-mask.md) generator is a version of the Regex Mask generator that can be used for array values.

It uses regular expressions to parse strings and replace specified substrings with the output of specified generators. The parts of the string to replace are specified inside unnamed top-level capture groups.

## Link object structure <a href="#generator-api-array-regex-mask-link-object" id="generator-api-array-regex-mask-link-object"></a>

In the Array Regex Mask generator, each link object identifies a regular expression and the generators to apply to the resulting capture groups.

The generator does not in itself support consistency or allow you to configure differential privacy.

The `metadata` object for each link object is populated from the [`RegexMaskMetadata`](https://app.tonic.ai/apidocs/index.html#/models/RegexMaskMetadata) object, and includes:

* Whether to replace all matches or only the first match.
* The regular expression used to identify the capture groups to replace.
* The list of generator types to apply to each capture group. The first sub-generator is applied to the first capture group, the second generator to the second group, and so on.
* In the `captureGroupMetadata` object, the configuration for each generator in `captureGroupSubGenerators`. The sequence of the entries in `captureGroupMetadata` must match the sequence of the generators in `captureGroupSubGenerators`.

```json
{
  "schema": "string",
  "table": "string",
  "column": "string",
  "metadata": {
    "generatorId": "ArrayRegexMaskGenerator",
    "presetId": "ArrayRegexMaskGenerator",
    "replaceAllMatches": boolean,
    "pattern": "string",
    "captureGroupMetadata": [
      {
              //Metadata for a capture group generator
      }
    ]
  }
}
```

## Example replacement <a href="#generator-api-array-regex-mask-replacement" id="generator-api-array-regex-mask-replacement"></a>

The following example provides a regex pattern that produces a single capture group.

For that capture group, the Constant generator is applied. The capture group value is replaced with `test_value`.

```json
{
  "name": "character_col",
  "schema": "public",
  "table": "my_table",
  "links": [
    {
      "schema": "public",
      "table": "my_table",
      "column": "array_value",
      "metadata": {
        "generatorId": "ArrayRegexMaskGenerator",
        "presetId": "ArrayRegexMaskGenerator",
        "replaceAllMatches": true,
        "pattern": "(.*)",
        "captureGroupMetadata": [
          {
            "generatorId": "ConstantGenerator",
            "constant": "test_value"
          }
        ]
      }
    }
  ]
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.tonic.ai/app/api/quick-start-guide/tonic-api-generator-assignment/generator-api-reference/generator-api-ref-array-regex-mask.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
